/************************************************************************
**
**  Copyright (C) 2005  Christian Kranz
**
**  Siemens S65 Display Control
**
**  modded by Juergen Eckert
**
**  re-moddes by Marc Seiffert 
**
**  Circle-module given by Harry Sk. developed by unknown
**
************************************************************************/

#include <avr/io.h> 
#include <util/delay.h>
#include <avr/pgmspace.h>

#define S65_DISP_W 		132
#define S65_DISP_H 		176

#define LCD_CS	   B,4
#define LCD_RESET  B,1
#define LCD_RS	   B,0 // An PB7 hab ich die HG-Bel

// Info: Es wird Hardware-SPI verwendet vvvvvv
#define LCD_MOSI   B,5
#define LCD_MISO   B,6
#define LCD_SCK    B,7
// Info: Es wird Hardware-SPI verwendet ^^^^^^

#define PORT(p)		_PORT(p)
#define DDR(p)		_DDR(p)
#define PIN(p)		_PIN(p)
#define BIT(p)		_BIT(p)
#define MASK(p,w)	( _WIDTH(w) << _BIT(p) )
#define	_PORT(x,b)	PORT ## x
#define _DDR(x,b)	DDR ## x
#define _PIN(x,b)	PIN ## x
#define	_BIT(x,b)	P ## x ## b
#define	_WIDTH(w)	(0xff >> (8-w))
#define INPUT(p)	_DDR(p) &= ~(1<<_BIT(p))
#define OUTPUT(p)	_DDR(p) |= (1<<_BIT(p))
#define SET(p)		_PORT(p) |= (1<<_BIT(p))
#define CLR(p)		_PORT(p) &= ~(1<<_BIT(p))
#define	GET(p)		(!! ( _PIN(p) & ( 1<<_BIT(p) ) ) )

#define RGB(r,g,b) (((r & 0xF8) << 8) | ((g & 0xFC) << 3) | ((b & 0xF8)>> 3))


// -----------Alle Endbenutzerfunktionen--------------

// Hintergrundbeleuchtung. Einfach ignorieren wenn nicht gebraucht !
void	S65_HgBelInit(uint8_t Helligkeit);
void	S65_HgBelSet(uint8_t Helligkeit);
// Steuerroutinen
void 	S65_Init(void);
// Einfache Grafikoperationen
void 	S65_Pixel(uint8_t y, uint8_t x, uint16_t farbe);
void 	S65_Fillscreen(uint16_t color);
void	S65_allocatearea(uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2);
void 	S65_DrawLine(uint8_t y1, uint8_t x1, uint8_t y2, uint8_t x2, uint16_t color);
void 	S65_DrawRect(uint8_t y1,uint8_t x1,uint8_t y2,uint8_t x2,uint16_t c);
void 	S65_DrawFilledRect(uint16_t y1,uint16_t x1,uint16_t y2,uint16_t x2,uint16_t c);
void 	S65_Circle(uint8_t x0, uint8_t y0, uint8_t radius, uint16_t color);
// Setzen der Variablen der Textverarbeitung
void 	S65_SetFont(uint8_t *pointer);
void 	S65_SetRot(uint8_t r);
void 	S65_SetTextColor(uint16_t color);
void 	S65_SetTextTyp(uint8_t typ);
void 	S65_SetFNull(uint8_t fn);
void 	S65_SetNonTransparenz(uint8_t nt);
// Funktionen der Textverarbeitung
uint8_t	S65_PutChar(uint8_t x, uint8_t y,uint8_t c);
uint8_t	S65_PutStr(uint8_t x, uint8_t y, char *c);
// Erweiterte Textfunktionen
void 	S65_PutByte(uint8_t x, uint8_t y, uint8_t z);
void 	S65_PutInt(uint8_t x, uint8_t y, uint16_t z);
void 	S65_PutLong(uint8_t x, uint8_t y, uint32_t z);
// Setzen der Variablen fr die Bitmapverarbeitung
void 	S65_SetBmpTransparenz(uint8_t bt);
void 	S65_SetBmpTransFarbe(uint16_t color);
// Funktionen der Bitmapverarbeitung
void	S65_PutRawBmp16(uint8_t x, uint8_t y, uint8_t *pic, uint8_t w, uint8_t h);
void	S65_PutBmp(uint8_t x, uint8_t y, uint8_t *pic); // Achtung, Bug @ Kombrimierte Bmps !
void	S65_PutBmpFromIICEEP(uint8_t x, uint8_t y, uint8_t *Bild);
void	S65_PutBmpFromSD(uint8_t x, uint8_t y, uint8_t *Bild);


